#include <windows.h>
#include <ole2.h>

#include "textwin.h"
#include "oleobj.h"
#include "iclient.h"

#include "debug.h"

ImpIUnknown::ImpIUnknown(OleClientObj *p)
 : IUnknown()
{
	parent = p;
}

ImpIUnknown::~ImpIUnknown()
{
}

STDMETHODIMP ImpIUnknown::QueryInterface (REFIID niid,LPVOID FAR *ppvObj)
{
	return parent->QueryInterface(niid,ppvObj);
}

STDMETHODIMP_(ULONG) ImpIUnknown::AddRef()
{
	return parent->AddRef();
}

STDMETHODIMP_(ULONG) ImpIUnknown::Release()
{
	return parent->Release();
}

ImpIOleClientSite::ImpIOleClientSite(OleClientObj *p)
 : IOleClientSite()
 {
	parent = p;
 }

ImpIOleClientSite::~ImpIOleClientSite()
{
}

STDMETHODIMP ImpIOleClientSite::QueryInterface(REFIID niid,LPVOID FAR * ppvObj)
{
	return parent->QueryInterface(niid,ppvObj);
}

STDMETHODIMP_(ULONG) ImpIOleClientSite::AddRef()
{
	return parent->AddRef();
}

STDMETHODIMP_(ULONG) ImpIOleClientSite::Release()
{
	return parent->Release();
}

STDMETHODIMP ImpIOleClientSite::GetContainer(LPOLECONTAINER FAR* ppContainer)
{
 *ppContainer = NULL;
 return ResultFromScode(E_NOINTERFACE);
}

STDMETHODIMP ImpIOleClientSite::OnShowWindow(BOOL bShow)
{
  parent->OnShow(bShow);
  return ResultFromScode(S_OK);
}


STDMETHODIMP ImpIOleClientSite::GetMoniker(DWORD dwAssign,DWORD dwWhichMoniker,LPMONIKER FAR *ppmk)
{
   *ppmk = NULL;
   return ResultFromScode(E_NOTIMPL);
}

STDMETHODIMP ImpIOleClientSite::RequestNewObjectLayout()
{
   return ResultFromScode(E_NOTIMPL);
}

STDMETHODIMP ImpIOleClientSite::SaveObject()
{

   return parent->SaveObject();
}

STDMETHODIMP ImpIOleClientSite::ShowObject()
{
   return ResultFromScode(S_OK);
}

ImpIAdviseSink::ImpIAdviseSink(OleClientObj *p)
{
	parent = p;
}

ImpIAdviseSink::~ImpIAdviseSink()
{
}

STDMETHODIMP_(ULONG) ImpIAdviseSink::AddRef()
{
	return parent->AddRef();
}

STDMETHODIMP_(ULONG) ImpIAdviseSink::Release()
{
	return parent->Release();
}

STDMETHODIMP ImpIAdviseSink::QueryInterface (REFIID niid, LPVOID * ppInterface)
{
	return parent->QueryInterface(niid,ppInterface);
}

STDMETHODIMP_(void) ImpIAdviseSink::OnDataChange(LPFORMATETC pFormatetc,LPSTGMEDIUM pStg)
{
   parent->OnDataChange();
}

STDMETHODIMP_(void) ImpIAdviseSink::OnViewChange(DWORD dwAspect,LONG lIndex)
{
   parent->OnViewChange();
}

STDMETHODIMP_(void) ImpIAdviseSink::OnRename(LPMONIKER pMoniker)
{
}

STDMETHODIMP_(void) ImpIAdviseSink::OnSave()
{
   parent->OnViewChange();
}

STDMETHODIMP_(void) ImpIAdviseSink::OnClose()
{
   parent->OnClose();
}  