// header file defining MZ (DOS EXE) header typedef

#ifndef MMMZHEAD_H
#define MMMZHEAD_H

#define MZ_SIGVALUE     0x5A4D 		// 'MZ'

// Structure names based on EXEHDR output
// NEOffset is at 0x3c, DOS stub at 0x40
typedef struct tagMZHeader
{
    UINT MagicNumber ;
    UINT	cBytesOnLastPage ;
    UINT	cPagesInFile ;
    UINT	cRelocations ;
    UINT	ParagraphsInHeader ;
    UINT	ExtraParasNeeded ;
    UINT	ExtraParasWanted ;
    ULONG	InitialStack ;
    UINT	WordChecksum ;
    ULONG	EntryPoint ;
    UINT	RelocationTableAddress ;
    UINT	Overlay ;
    ULONG	Reserved ;
    char Reserved2[28] ;
    struct tagNEHeader *pThisNE ;
} MZHEADER ;

#endif // MMMZHEAD_H
